<?php


namespace app\shequ\controller;


//车位及车辆管理
use app\admin\controller\Common;
use think\facade\Db;
use think\facade\Request;

class Parking extends Base
{
    protected $middleware = ['app\middleware\CommunityLoginCheck::class','app\middleware\CommunityAfter::class'];


    //添加车位区块
    public function createParkArea() {
        $park_block_id = Request::param('park_block_id');
        $data['village_id'] = $this->village_id;
        $data['name'] = Request::param('name');
        $data['sort_id'] = Request::param('sort_id');
        $data['explain'] = Request::param('explain');
        //修改
        if($park_block_id) {
            $where['park_block_id'] = $park_block_id;
            $operation = Db::name('park_block')->where($where)->update($data);
        } else{
            $data['create_time'] = time();
            $operation = Db::name('park_block')->save($data);
        }
        if($operation) {
            return  $this->returnJson([],'success');
        } else {
            return  $this->returnJson([],'操作失败',400);
        }
    }

    //删除车位区块
    public function deleteParkArea() {
        $where['village_id'] = $this->village_id;
        $where['park_block_id'] = Request::param('park_block_id');
        //查看该区域下是否有车位
        $is_exit = Db::name('park_car')->where($where)->find();
        if($is_exit) {
            return $this->returnJson([],'该区域下有车位,请先删除车位!',400);
        }
        $del = Db::name('park_block')->where($where)->delete();
        if($del) {
            return $this->returnJson([],'success');
        } else {
            return $this->returnJson([],'删除失败',400);
        }
    }


    //车位区域列表
    public function parkAreaList() {
        $page= Request::param('page',1);
        $where['village_id'] = $this->village_id;
        $res['total'] = Db::name('park_block')->where($where)->count();
        $data = Db::name('park_block')->where($where)->order('sort_id','desc')->page($page,config('app.limit'))->select()->toArray();
        $res['data'] =Common::changeField($data);
        return $this->returnJson($res,'success');
    }


    //添加车位
    public function createCarArea() {
        $park_car_id = Request::param('park_car_id');
        $data['vacancy_code'] = Request::param('vacancy_code');
        $data['village_id'] =  $this->village_id;
        $data['vacancy_id'] =  Db::name('house_vacancy')->where($data)->value('vacancy_id');
        $data['park_code'] = Request::param('park_code');
        $data['sort_id'] = Request::param('sort_id');
        $data['explain'] = Request::param('explain');
        $data['park_block_id'] = Request::param('park_block_id');
        if($park_car_id) { //修改
            $where['park_car_id'] = $park_car_id;
            $operation = Db::name('park_car')->where($where)->save($data);
        } else {
            $data['create_time'] = time();
            $operation = Db::name('park_car')->save($data);
        }

        if($operation) {
            return $this->returnJson([],'success');
        } else {
            return $this->returnJson([],'操作失败',400);
        }

    }


    //删除车位
    public function deleteCarArea() {
        $where['village_id'] = $this->village_id;
        $where['park_car_id'] = Request::param('park_car_id');
        $del = Db::name('park_car')->where($where)->delete();
        if($del) {
            return $this->returnJson([],'success');
        } else {
            return $this->returnJson([],'操作失败',400);
        }
    }


    //车位列表
    public function carAreaList() {
        $vacancy = new Vacancy($this->app);
        $page = Request::param('page',1);
        $park_block_id = Request::param('park_block_id');
        $park_code = Request::param('park_code');
        $vacancy_code = Request::param('vacancy_code');
        $where[] = ['pc.village_id','=',$this->village_id];
        if($park_block_id) {
            $where[] = ['pc.park_block_id','=',$park_block_id];
        }
        if($park_code) {
            $where[] = ['pc.park_code','=',$park_code];
        }
        if($vacancy_code) {
            $where[] = ['pc.vacancy_code','=',$vacancy_code];
        }
        $data = Db::name('park_car')->alias('pc')->leftJoin('house_vacancy hv','hv.vacancy_id = pc.vacancy_id')->where($where)->order('sort_id','desc')->page($page,config('app.limit'))
            ->field('pc.*,hv.vacancy_code')
            ->select()->toArray();
        foreach ($data as $k =>$v) {
            $data[$k]['vacancy_address'] = $vacancy->getVacancyAddress($v['vacancy_code']);
        }
        $total = Db::name('park_car')->alias('pc')->leftJoin('house_vacancy hv','hv.vacancy_id = pc.vacancy_id')->where($where)->count();
        $res['total'] = $total;
        $res['data'] = $data;
        return $this->returnJson($res,'success');
    }



    //添加|修改车辆
    public function createCar() {
        
    }

    //删除车辆

    public function deleteCar() {


    }

    //车辆列表

    public function CarList() {

    }







}